using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Routing;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.JsonPatch;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;

using AyaNova.Models;
using AyaNova.Api.ControllerHelpers;
using AyaNova.Biz;


namespace AyaNova.Api.Controllers
{
    //DOCUMENTATING THE API
    //https://docs.microsoft.com/en-us/dotnet/csharp/programming-guide/xmldoc/recommended-tags-for-documentation-comments
    //https://github.com/domaindrivendev/Swashbuckle.AspNetCore#include-descriptions-from-xml-comments

    /// <summary>
    /// Sample controller class used during development for testing purposes
    /// </summary>
    [ApiVersion("8.0")]
    [Route("api/v{version:apiVersion}/[controller]")]
    [Produces("application/json")]
    [Authorize]
    public class DataFilterController : Controller
    {
        private readonly AyContext ct;
        private readonly ILogger<DataFilterController> log;
        private readonly ApiServerState serverState;


        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="dbcontext"></param>
        /// <param name="logger"></param>
        /// <param name="apiServerState"></param>  
        public DataFilterController(AyContext dbcontext, ILogger<DataFilterController> logger, ApiServerState apiServerState)
        {
            ct = dbcontext;
            log = logger;
            serverState = apiServerState;
        }


        /// <summary>
        /// Get full DataFilter object
        /// 
        /// Required roles:
        /// Any (for public filter), owned only for private filter
        /// </summary>
        /// <param name="id"></param>
        /// <returns>A single DataFilter</returns>
        [HttpGet("{id}")]
        public async Task<IActionResult> GetDataFilter([FromRoute] long id)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            //Instantiate the business object handler
            DataFilterBiz biz = DataFilterBiz.GetBiz(ct, HttpContext);

            if (!Authorized.IsAuthorizedToReadFullRecord(HttpContext.Items, biz.BizType))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            var o = await biz.GetAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            return Ok(new ApiOkResponse(o));
        }



        /// <summary>
        /// Get DataFilter pick list
        /// 
        /// Required roles: Any
        /// 
        /// </summary>
        /// <returns>List of public or owned data filters for listKey provided</returns>    
        [HttpGet("PickList", Name = nameof(DataFilterPickList))]
        public async Task<IActionResult> DataFilterPickList([FromQuery] string ListKey)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler
            DataFilterBiz biz = DataFilterBiz.GetBiz(ct, HttpContext);
            
            var l = await biz.GetPickListAsync(ListKey);
            return Ok(new ApiOkResponse(l));

        }


        /// <summary>
        /// Put (update) DataFilter
        /// 
        /// Required roles:
        /// Any (public filter) or owned only (private filter)
        /// 
        /// </summary>
        /// <param name="id"></param>
        /// <param name="inObj"></param>
        /// <returns></returns>
        [HttpPut("{id}")]
        public async Task<IActionResult> PutDataFilter([FromRoute] long id, [FromBody] DataFilter inObj)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler       
            DataFilterBiz biz = DataFilterBiz.GetBiz(ct, HttpContext);

            var o = await biz.GetNoLogAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            if (!Authorized.IsAuthorizedToModify(HttpContext.Items, biz.BizType, o.OwnerId))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            try
            {
                if (!biz.Put(o, inObj))
                    return BadRequest(new ApiErrorResponse(biz.Errors));
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!await biz.ExistsAsync(id))
                    return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
                else
                    return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
            }
            return Ok(new ApiOkResponse(new { ConcurrencyToken = o.ConcurrencyToken }));
        }


        /// <summary>
        /// Post DataFilter
        /// 
        /// Required roles: 
        /// BizAdminFull, InventoryFull, TechFull
        /// </summary>
        /// <param name="inObj"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IActionResult> PostDataFilter([FromBody] DataFilter inObj)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            //Instantiate the business object handler
            DataFilterBiz biz = DataFilterBiz.GetBiz(ct, HttpContext);

            //If a user has change roles, or editOwnRoles then they can create, true is passed for isOwner since they are creating so by definition the owner
            if (!Authorized.IsAuthorizedToCreate(HttpContext.Items, biz.BizType))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Create and validate
            DataFilter o = await biz.CreateAsync(inObj);
            if (o == null)
                return BadRequest(new ApiErrorResponse(biz.Errors));
            else
                return CreatedAtAction("GetDataFilter", new { id = o.Id }, new ApiCreatedResponse(o));

        }



        /// <summary>
        /// Delete DataFilter
        /// 
        /// Required roles:
        /// Any if public otherwise creator only
        /// 
        /// </summary>
        /// <param name="id"></param>
        /// <returns>Ok</returns>
        [HttpDelete("{id}")]
        public async Task<IActionResult> DeleteDataFilter([FromRoute] long id)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(ApiErrorCode.API_CLOSED, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler
            DataFilterBiz biz = DataFilterBiz.GetBiz(ct, HttpContext);

            var o = await biz.GetNoLogAsync(id);
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            if (!Authorized.IsAuthorizedToDelete(HttpContext.Items, biz.BizType, o.OwnerId))
                return StatusCode(401, new ApiNotAuthorizedResponse());

            if (!biz.Delete(o))
                return BadRequest(new ApiErrorResponse(biz.Errors));

            return NoContent();
        }

        //------------


    }//eoc
}//eons